<?php
require_once(ROOTDIR."/include/database/class.ServerQueries.php");
require_once(ROOTDIR."/include/database/class.UserQueries.php");
require_once(ROOTDIR."/include/class.rcon.php");

$serverId = $_GET['serverId'];

$serverQueries = new ServerQueries();
$userQueries = new UserQueries();

$server = $serverQueries->getServer($serverId);
$users = $userQueries->getUsers();

// Create an rcon object to connect to a single server on each iteration
$r = new rcon($server->getIp(),$server->getPort(),$server->getRcon());
$active = 0;

// Make sure it connected to the server
if($r->isValid()) {
  $r->Auth(); // Establish the connection
  $active = 1;
  // First delete the existing clanMembers keygroup and then re-create it
  $r->sendRconCommand("es_keygroupdelete clanMembers; es_keygroupcreate clanMembers");

  // Cycle through each user and create the keygroup
  foreach($users as $user) {

    $admin = 0;

    // Determine if the user has "admin" privileges
    if($user->getAccessLevel() == 4) {
      $admin = 0;
    } else {
      $admin = 1;
    }

    // Create a key for the user
    $command = "cdb_addMember \"".$user->getSteamId()."\" \"".$user->getName()."\" 1 ".$admin;
    $r->sendRconCommand($command);
  }

  // Now save the keygroup
  $r->sendRconCommand("es_keygroupsave clanMembers |GlobalBan");

  // Now reload the GlobalBan script
  $r->sendRconCommand("es_reload GlobalBan");
}
// Send back the new active state
header('Content-Type: text/xml');
header("Cache-Control: no-cache, must-revalidate");

function convertXmlSpecial($string) {
  $string = str_replace("&", "&amp;", $string);
  $string = str_replace("'", "&apos;", $string);
  $string = str_replace("\"", "&quot;", $string);
  $string = str_replace("<", "&lt;", $string);
  $string = str_replace(">", "&gt;", $string);
  return $string;
}
?>
<?echo "<?xml version=\"1.0\" ?>";?>
<root>
  <id><?=$server->getId()?></id>
	<name><?=convertXmlSpecial($server->getName())?></name>
	<active><?=$active?></active>
</root>
