<?php
/****************************************************************************************************** 
	This class contains all queries that deal with the gban_reason table
******************************************************************************************************/

require_once(ROOTDIR."/include/database/class.Database.php"); //Database class
require_once(ROOTDIR."/include/objects/class.Reason.php");

class ReasonQueries {	

	// Variables
	var $db; // Object of database class
	
	// Default constructor
	function __construct() {
		$this->init();
  }
  
	function ReasonQueries() {
		$this->init();
  }
  
  function init() {
    $this->db = new Database; // Create new database connection for this object
  }
  
  /************************************************************************
	Gets the list of reasons with their reason id
	************************************************************************/
  function getReasonList() {  
    $reasonQuery = "SELECT reason_id, reason FROM gban_reason ORDER BY reason_id";
    $this->db->sql_query($reasonQuery);    
    
    $reasonList = array();
    
    $reasons = $this->db->get_array();
    
    for($i=0; $i<count($reasons); $i++) {
      $reason = new Reason();
      
      $reason->setId($reasons[$i]['reason_id']);
      $reason->setReason($reasons[$i]['reason']);
      
      array_push($reasonList, $reason); // Add the reason object to the array
    }
    
    return $reasonList;
  }
  
  /************************************************************************
	Add a new reason
	************************************************************************/
  function addReason($addReason) {
    $addReasonQuery = "INSERT INTO gban_reason (reason) 
    values('".addslashes($addReason)."')";
    $this->db->sql_query($addReasonQuery);
  
    return $this->db->get_insert_id();
  }
  
  /************************************************************************
	Delete an existing reason by id
	************************************************************************/
  function deleteReason($id) {
    $deleteReasonQuery = "DELETE FROM gban_reason WHERE reason_id = '".$id."'";
    $this->db->sql_query($deleteReasonQuery);
  }
  
  /************************************************************************
	Update an existing ban reason with new text
	************************************************************************/
  function updateBanReason($reason, $id) {
    $this->db->sql_query("UPDATE gban_reason 
                    SET reason='".addslashes($reason)."'
                    WHERE reason_id = '".$id."'");
  }
  
  /************************************************************************
	Get the first server that is listed in the server table
	************************************************************************/
  function getFirstReason() {
    $sql = "SELECT MIN( reason_id ) as min FROM `gban_reason`";
    $this->db->sql_query($sql);
    $id = $this->db->get_row();
    return $id['min'];
  }
}
?>
